#pragma once

/* Structure used to send and receive msgs*/
class Response {
 public:
  int task_number;
  int s, t;
  int graph_size;
  double flow; /* max flow */
  double time_per_mincut;
  int num_of_cuts;
  float balance_factor; // measure of how balanced is the cut
  int *cut;    /* list of vertices on s side */
  // WARNING: if you change the fields, check the reply_buffer allocation size and MPI pack/unpack

  Response(int n);
  ~Response();
};

struct Task {
  int task_number;
  int s, t;
  int pivot_size; 
  int part_len; // partition size or the pivot degree
  // WARNING: if you add new fields, check the task_buffer allocation size

  Task();
  Task (int task_number, int s, int t, int pivot_size, int part_len);
  ~Task();
};

